<template>
  <div class="q-pa-md">
    <div class="column">
      <div class="col " style="text-align: right">
        <q-btn tag="a" to="/kategori/tambah" color="blue" icon="add" label="Tambah Kategori Produk" />
      </div>
    </div>

    <div class="column flex-center">
      <div class="col" style="margin-top: 10px; width: 100%;">
        <q-table
          class="my-sticky-header-table"
          title="Daftar Referensi Kategori Produk"
          :data="dataTable"
          :columns="columns"
          row-key="name"
        >
          <template v-slot:top-right style="color: white !important;">
            <q-input borderless dense debounce="300" v-model="filter" placeholder="Cari Jenis Produk" color="white">
              <template v-slot:append style="color: white">
                <q-icon name="search"  />
              </template>
            </q-input>
          </template>

          <template v-slot:body="props">
            <q-tr :props="props" :key="`m_${props.row.index}`">
              <q-td
                key="index"
                :props="props"
              >
                {{ props.row.index }}.
              </q-td>
              <q-td key="img_web" :props="props" >
                <q-img
                  style="width: 100px; height: 30px"
                  :ratio="1"
                  class="rounded-borders"
                  :src="props.row.img_web"
                />
              </q-td>
              <q-td key="img_mobile" :props="props" >
                <q-img
                  style="width: 100px; height: 30px"
                  :ratio="1"
                  class="rounded-borders"
                  :src="props.row.img_mobile"
                />
              </q-td>
              <q-td key="product_type" :props="props" >{{ props.row.jenis_produk }}</q-td>
              <q-td key="category" :props="props" >{{ props.row.category }}</q-td>
              <q-td key="category_desc" :props="props" >{{ props.row.category_desc }}</q-td>
              <q-td key="status" :props="props" >
                <q-badge align="middle" color="blue" v-if="props.row.status">Aktif</q-badge>
                <q-badge align="middle" color="red" v-else>Tidak Aktif</q-badge>
              </q-td>
              <q-td key="creator" :props="props" >{{ props.row.creator }}</q-td>
              <q-td key="tanggal_update" :props="props" >{{ props.row.tanggal_update }}</q-td>
              <q-td key="aksi" :props="props" >
                <q-btn
                  padding="none"
                  color="primary"
                  icon="edit"
                  :to="`kategori/edit/${props.row.id}`"
                />
                <q-btn
                  style="margin-left: 3px"
                  padding="none"
                  color="primary"
                  icon="delete"
                  @click="confirmDelete(props.row.id, props.row.category)"
                />
              </q-td>
            </q-tr>
          </template>
        </q-table>
      </div>
    </div>

  </div>
</template>

<script>
  export default {
    name: "ListInvestor",

    data () {
      return {
        filter: null,
        columns: [
          {
            name: 'index',
            required: true,
            label: 'No',
            align: 'left',
            field: 'index',
            format: val => `${val}`,
            sortable: true
          },
          { name: 'img_web', align:'left', label: 'Icon Web', field: 'img_web', sortable: true },
          { name: 'img_mobile', align:'left', label: 'Icon Mobile', field: 'img_mobile', sortable: true },
          { name: 'product_type', align:'left', label: 'Jenis Produk', field: 'jenis_produk', sortable: true },
          { name: 'category', align:'left', label: 'Kategori', field: 'category', sortable: true },
          { name: 'category_desc', label: 'Deskripsi', field: 'category_desc', sortable: true },
          { name: 'status', label: 'Status', field: 'status' },
          { name: 'creator', label: 'Update By', field: 'creator' },
          { name: 'tanggal_update', label: 'Last Update', field: 'tanggal_update' },
          { name: 'aksi', label: 'Aksi', field: 'id' }
        ],
        dataTable: [],
      }
    },

    beforeMount() {
      this.getBadanUsaha();
    },

    methods: {
      async getBadanUsaha() {
        let dataApi = {
          methods: "get",
          url: "api/category/list",
          headers: {
            Authorization: "Bearer " + localStorage.getItem("token")
          }
        }

        this.$q.loading.show()
        await this.$axios(dataApi)
          .then(sukses => {
            this.dataTable = sukses.data.data
            this.dataTable.forEach((row, index) => {
              row.index = index + 1
              let update = new Date(row.updated_at);
              row.tanggal_update = update.toLocaleDateString() + " , " +  update.toLocaleTimeString();
            })
          })
          .catch(error => {
            console.log(error.response)

          })
          .then(selalu => {
            this.$q.loading.hide()
          })
      },

      confirmDelete(val, name) {
          this.$q.dialog({
            title: 'Konfirmasi',
            message: 'Yakin Menghapus Kategori' + name + "?",
            cancel: true,
            persistent: true
          }).onOk(() => {
            this.$router.push(`kategori/delete/${val}`);
          }).onOk(() => {
            // console.log('>>>> second OK catcher')
          }).onCancel(() => {
            // console.log('>>>> Cancel')
          }).onDismiss(() => {
            // console.log('I am triggered on both OK and Cancel')
          })
      },

      filterBadanUsaha: function () {
        alert("oke")
      }
    }
  }
</script>

<style lang="sass">
  .q-table--no-wrap td
    white-space: normal

    .my-sticky-header-table

      .q-table__top,
      .q-table__bottom,
      thead tr:first-child th
        /* bg color is important for th; just specify one */
        background-color: #009688
        color: white
        font-size: 16px

      thead tr th
        position: sticky
        z-index: 1
      thead tr:first-child th
        top: 0

      /* this is when the loading indicator appears */
      &.q-table--loading thead tr:last-child th
        /* height of all previous header rows */
        top: 48px
</style>

<style>
thead {
  background-color: #c2c2c2;
}
.q-table__title {
  font-weight: bold;
}

</style>
